﻿Type=StaticCode
Version=5.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Code module Graphics
Sub Process_Globals

End Sub

'Checks if a point p(x, y) is in a apolygon polx(), poly() 
Public Sub CheckPointInPolygone(polx() As Double, poly() As Double, x As Double, y As Double) As Boolean
	Dim x1, y1, x2, y2, D As Double
	Dim i, ni As Int
	
	ni = 0
	x1 = polx(0)
	y1 = poly(0)
	For i = 1 To polx.Length
		If i < polx.Length Then
			x2 = polx(i)
			y2 = poly(i)
		Else
			x2 = polx(0) 	' checks the last line
			y2 = poly(0)
		End If
		
		
		If y >= Min(y1, y2) Then
			If y <= Max(y1, y2) Then
				If x <= Max(x1, x2) Then
					If (x = x1 And y = y1) Or (x = x1 And x = x2) Then
						Return True 
					End If
					If y1 <> y2 Then
						D = (y - y1) * (x2 - x1) / (y2 - y1) + x1
						If x1 = x2 Or x <= D Then
							ni = ni + 1
						End If
					End If
				End If
			End If
		End If
		x1 = x2
		y1 = y2
	Next
	
	If ni Mod 2 = 0 Then
		Return False 
	Else
		Return True 
	End If	
End Sub

'Returns the distance between a point p(x, y) and line defined by the two points p(xa, ya) and p(xb, yb)
Public Sub CalcDistanceLinePoint(xa As Double, ya As Double, xb As Double, yb As Double, x As Double, y As Double) As Double
	Dim a, b, c, d As Double
	
	a = yb - ya
	b = xa - xb
	c = -a * xa - b * ya
	d = (a * x + b * y + c) / Sqrt(a * a + b * b)	
	Return d
End Sub

'Checks if a point p(x, y) is in a apolygon polx(), poly() or in the surrounding within the given Distance 
'Returns 
'  1 if the point is in the polygon
'  2 if the point is in the surrounding
'  0 if the point is outides the surrounding 
Public Sub CheckPointInPolygonSurroundig(polx() As Double, poly() As Double, x As Double, y As Double, Distance As Double) As Int
	Dim x1, y1, x2, y2, D, dc As Double
	Private i As Int
	
	D = Distance
	
	If CheckPointInPolygone(polx, poly, x, y) = True Then
		Return 1
	End If
	
	For i = 0 To polx.Length - 1
		If i < polx.Length - 1 Then
			x1 = polx(i)
			y1 = poly(i)
			x2 = polx(i + 1)
			y2 = poly(i + 1)
		Else
			x1 = polx(i)
			y1 = poly(i)
			x2 = polx(0)
			y2 = poly(0)
		End If
		If x >= Min(x1 - Distance, x2 - Distance) And x <= Max(x1 + Distance, x2 + Distance) And y >= Min(y1 - Distance, y2 - Distance) And y <= Max(y1 + Distance, y2 + Distance) Then
			dc = CalcDistanceLinePoint(x1, y1, x2, y2, x, y)
			If Abs(dc) <= D Then
				Return 2
			End If
		End If
	Next
	Return 0
End Sub